#ifndef _StateTree_hh_
#define _StateTree_hh_

#include <vector>
#include "RENode.hh"
#include "common.hh"

class RENode;
class Symbol;
class Token;

class Tree
{
private:
  RENodeList * leaves;
  TokenString * inputString;
  RENode * root;
  Tree * original;
  
public:
#ifdef _OLD_STUFF_
  /** add a child to the specified leaf node. */
  RENodeI addBranch(RENodeI parent, Symbol * rw, Token * exactToken =0);
  /** add a number of children to the specified leaf node. */
  RENodeI addBranch(RENodeI parent, Symbol * rw, vector<Token*>* exactTokens);
#endif
  /** add the specified children to the specified leaf node. */
  RENodeI addBranch(RENodeI parent, Symbol * rw, vector<RENode*>* exactNodes);
  /** destroy all nodes in specified branch. */
  RENodeI removeBranch(RENodeI leaf);
  /** destroy all nodes in tree. */
  void clear();
  /** get first leaf in list. */
  RENodeI begin() const;
  /** get last leaf in list. */
  RENodeI end() const;
  /** get the number of leaf nodes */
  unsigned int size() const;
  /** get the inputstring */
  TokenString * getInput() const;
  /** commit changes from a copy to the original */
  void commit();
  /** stringify */
  string toString() const;
  
  Tree(RENode * r);
  Tree(Tree * tree);
  ~Tree();
};

#endif
