#ifndef _Rule_hh_
#define _Rule_hh_

#include <list>
#include <string>

#include "common.hh"
//#include "Symbol.hh"

class Rule;
class Symbol;
class RegExpr;
class SRNode;

typedef list<Rule*> Rules;
typedef list<Symbol*> Synonyms;

class Rule
{
private:
#ifdef _OLD_STUFF_
  virtual void doMatch(SRNode*, list<SRNode*>* );
#endif
public:
  static unsigned int matchInvoked;
  
  Symbol * left;
  RegExpr * right;
  
  /**
   * Modifier that determines when this rule is applicable. 
   *
   * ' ' = always applicable.
   * '+' = never use this rule to generate nodes with < 2 children.
   * '!' = never use this rule to generate the root node.
   */
  char modifier;
  
  Rule(Symbol  * l = 0, 
       RegExpr * r = 0,
       char m=' ') :
    left(l), right(r), modifier(m)
    {}
  
  virtual list<SRNode*>* match(list<SRNode*> * state);
#ifdef _OLD_STUFF_
  virtual list<SRNode*>* match(map<string,SRNode*> * state);
#endif
  virtual string toString() const;
};

#endif
